#  This program may be used, executed, copied, modified and distributed
#  without royalty for the purpose of developing, using, marketing, or distributing.
#
#  useWVEBB.py - enables WVE to use its own internal bulletin board implementation 
#
# @author - brian.k.martin 
#
#=====================================================================================================================

disableHAM=0
disableAppServerHAM=0

def convertToList(inlist):
     outlist=[]
     if (len(inlist)>0 and inlist[0]=='[' and inlist[len(inlist)-1]==']'):
        inlist = inlist[1:len(inlist)-1]
        clist = inlist.split(" ")
     else:
        clist = inlist.split("\n")
     for elem in clist:
        elem=elem.rstrip();
        if (len(elem)>0):
           outlist.append(elem)
     return outlist


def doDisableHAM(servers):
   for server in servers:
       hamserver=AdminConfig.list("HAManagerService",server)
       if (hamserver != "" and hamserver != None):
            modifyServer=1
            if (disableAppServerHAM>0):
               serverType=AdminConfig.showAttribute(server,"serverType")
               if (serverType == "ONDEMAND_ROUTER" or serverType == "DEPLOYMENT_MANAGER" or serverType == "NODE_AGENT"):
                   print "skipping ",server
                   modifyServer=0
            if (modifyServer>0):
                AdminConfig.modify(hamserver,[["enable","false"]])


if (len(sys.argv)>0):
   if sys.argv[0] == "-disableHAM":
      disableHAM=1
   elif sys.argv[0] == "-disableAppServerHAM":
      disableAppServerHAM=1
   else:
      print "unrecognized option: ",sys.argv[0]
      sys.exit(1)

cell = AdminConfig.getid("/Cell:/")
properties = convertToList(AdminConfig.showAttribute(cell,"properties"))
for property in properties:
     name = AdminConfig.showAttribute(property,"name")
     value = AdminConfig.showAttribute(property,"value")
     if (name == "WXDBulletinBoardProviderOption"):
         AdminConfig.remove(property)
AdminConfig.create("Property",cell,[["name","WXDBulletinBoardProviderOption"],["value","WXD"]])

if disableHAM>0 or disableAppServerHAM>0:
   print "processing servers"
   servers=convertToList(AdminConfig.list("Server"))
   doDisableHAM(servers)
   servers=convertToList(AdminConfig.listTemplates("Server"))
   doDisableHAM(servers)

AdminConfig.save()
print "finished."
